"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FormikNumberSelectField = exports.FormikNumberSelect = void 0;

var _react = _interopRequireWildcard(require("react"));

var _formik = require("formik");

var _practicalReactComponentsCore = require("practical-react-components-core");

var _excluded = ["name", "validate", "options", "value"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var FormikNumberSelect = _ref => {
  var {
    name,
    validate,
    options,
    value
  } = _ref,
      props = _objectWithoutProperties(_ref, _excluded);

  var [field, meta, {
    setValue,
    setTouched
  }] = (0, _formik.useField)({
    name,
    validate
  });
  var optionString = (0, _react.useMemo)(() => options.map(v => _objectSpread(_objectSpread({}, v), {}, {
    value: v.value.toString()
  })), [options]);
  var onBlur = (0, _react.useCallback)(() => setTouched(true), [setTouched]);
  var onChange = (0, _react.useCallback)(selectValue => setValue(Number(selectValue)), [setValue]);
  return /*#__PURE__*/_react.default.createElement(_practicalReactComponentsCore.SelectField, _extends({}, field, {
    onChange: onChange,
    onBlur: onBlur,
    options: optionString,
    value: value === undefined ? field.value.toString() : value.toString(),
    error: meta.touched ? meta.error : undefined
  }, props));
};

exports.FormikNumberSelect = FormikNumberSelect;
var FormikNumberSelectField = (0, _practicalReactComponentsCore.withField)(FormikNumberSelect);
exports.FormikNumberSelectField = FormikNumberSelectField;